package gui211;

import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.LayoutManager;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JTextArea;

public class LayoutDemo {

	public static void main(String[] args) {
		showLayout("FlowLayout", new FlowLayout());
		showLayout("GridLayout", new GridLayout(3,3));
		showLayout("GridBagLayout", new GridBagLayout());
		showLayout("BorderLayout", new BorderLayout());
		showLayout("CardLayout", new CardLayout(5, 5));
	}

	static void showLayout(String name, LayoutManager lm) {
		JFrame top = new JFrame("Layout by " + name);
		top.setSize(300,300);
		Container p = top.getContentPane();
		p.setLayout(lm);
		
		for (int i = 0; i < 5; i++) {

			JComponent b = new JButton("button" + i);
			Object constraint = getConstraint(lm, b, i);
			p.add(b, constraint);
		}
		top.setVisible(true);
		top.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

	}
	static Object getConstraint(LayoutManager lm, JComponent b, int i) {

		if (lm instanceof GridBagLayout) {
			GridBagConstraints c = new GridBagConstraints();
			c.weightx = i; c.weighty = 1;
			return c;
		}
		if (lm instanceof BorderLayout) {
			String[] sides = new String[] { BorderLayout.CENTER,
									BorderLayout.NORTH, BorderLayout.EAST,
									BorderLayout.SOUTH, BorderLayout.WEST };
		
			return sides[i];
		}
		return null;
	}
	
}
